<?php
class FirstVersionOfTheLoyaltyPointsPlugin extends CakeMigration {

/**
 * Migration description
 *
 * @var string
 */
	public $description = 'first_version_of_the_loyalty_points_plugin';

/**
 * Actions to be performed
 *
 * @var array $migration
 */
	public $migration = array(
		'up' => array(
			'create_table' => array(
				'ev_loyalty_points_point_value' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'currency_id' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'points_per_unit' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'points_earnt_per_unit' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'minimum_spend' => array('type' => 'float', 'null' => true, 'default' => null, 'length' => '12,6', 'unsigned' => false),
					'created' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'modified' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
					),
					'tableParameters' => array('charset' => 'utf8', 'collate' => 'utf8_general_ci', 'engine' => 'InnoDB'),
				),
				'ev_loyalty_points_points' => array(
					'id' => array('type' => 'integer', 'null' => false, 'default' => null, 'unsigned' => false, 'key' => 'primary'),
					'user_id' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'model' => array('type' => 'string', 'null' => true, 'default' => null, 'length' => 250, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'model_id' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'description' => array('type' => 'text', 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'points' => array('type' => 'integer', 'null' => true, 'default' => null, 'unsigned' => false),
					'is_debit' => array('type' => 'boolean', 'null' => true, 'default' => '0'),
					'admin_note' => array('type' => 'text', 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'charset' => 'utf8'),
					'created' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'modified' => array('type' => 'datetime', 'null' => true, 'default' => null),
					'indexes' => array(
						'PRIMARY' => array('column' => 'id', 'unique' => 1),
					),
					'tableParameters' => array('charset' => 'utf8', 'collate' => 'utf8_general_ci', 'engine' => 'InnoDB'),
				),
			),
		),
		'down' => array(
			'drop_table' => array(
				'ev_loyalty_points_point_value', 'ev_loyalty_points_points'
			),
		),
	);

/**
 * Before migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return bool Should process continue
 */
	public function before($direction) {
		return true;
	}

/**
 * After migration callback
 *
 * @param string $direction Direction of migration process (up or down)
 * @return bool Should process continue
 */
	public function after($direction) {
		return true;
	}
}
